﻿namespace UltraGridDifferenCardViews
{
    using System;
    using System.Data;
    using System.Windows.Forms;

    public partial class Form1 : Form
    {
        public Form1()
        {
            this.InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            DataSet ds = this.GetData();
            this.ultraGrid1.DataSource = ds;
            this.ultraGrid1.DataMember = "Parent";
            this.ultraGrid1.Rows.ExpandAll(true);

            this.ultraGrid1.DisplayLayout.Bands[1].CardView = true;
            this.ultraGrid1.DisplayLayout.Bands[1].CardSettings.Style = Infragistics.Win.UltraWinGrid.CardStyle.MergedLabels;
            this.ultraGrid1.DisplayLayout.Bands[1].Columns["ParentID"].Hidden = true;

            this.ultraGrid1.DisplayLayout.Bands[2].CardView = true;
            this.ultraGrid1.DisplayLayout.Bands[2].CardSettings.Style = Infragistics.Win.UltraWinGrid.CardStyle.MergedLabels;
            this.ultraGrid1.DisplayLayout.Bands[2].Columns["ParentID"].Hidden = true;
        }

        private DataSet GetData()
        {
            DataSet ds = new DataSet();
            DataTable parent = ds.Tables.Add("Parent");
            parent.Columns.Add("ID", typeof(int));
            parent.Columns.Add("Created", typeof(DateTime));
            parent.Columns.Add("Owner", typeof(string));

            parent.Rows.Add(new object[] { 1, DateTime.Today.AddDays(1), "Simon" });
            parent.Rows.Add(new object[] { 2, DateTime.Today.AddDays(2), "Greg" });

            DataTable childWithCost = ds.Tables.Add("WithCost");
            childWithCost.Columns.Add("ID", typeof(int));
            childWithCost.Columns.Add("Cost", typeof(double)).AllowDBNull = true;
            childWithCost.Columns.Add("Description", typeof(string));
            childWithCost.Columns.Add("ParentID", typeof(int));

            childWithCost.Rows.Add(new object[] { 1, 5.45, "Line Item 1", 1 });
            childWithCost.Rows.Add(new object[] { 2, 12.05, "Line Item 2", 1 });
            childWithCost.Rows.Add(new object[] { 3, 16.00, "Line Item 3", 1 });

            ds.Relations.Add(parent.Columns["ID"], childWithCost.Columns["ParentID"]);

            DataTable childLessCost = ds.Tables.Add("LessCost");
            childLessCost.Columns.Add("ID", typeof(int));
            childLessCost.Columns.Add("Description", typeof(string));
            childLessCost.Columns.Add("ParentID", typeof(int));

            childLessCost.Rows.Add(new object[] { 4, "Line Item 4", 2 });
            childLessCost.Rows.Add(new object[] { 5, "Line Item 5", 2 });

            ds.Relations.Add(parent.Columns["ID"], childLessCost.Columns["ParentID"]);

            return ds;
        }
    }
}
